Index: /palm/trunk/SOURCE/chem_modules.f90
===================================================================
--- /palm/trunk/SOURCE/chem_modules.f90	(revision 4371)
+++ /palm/trunk/SOURCE/chem_modules.f90	(revision 4372)
@@ -22,12 +22,16 @@
 ! Current revisions:
 ! -----------------
-! 
+!
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! added namelist flag 'emiss_read_legacy_mode' to allow concurrent
+! functioning of new emission read mode under development (ECC)
+!
+! 4273 2019-10-24 13:40:54Z monakurppa 
 ! Add logical switches nesting_chem and nesting_offline_chem (both .TRUE.
 ! by default)
-! 
+!
 ! 4182 2019-08-22 15:20:23Z scharf
 ! Corrected "Former revisions" section
@@ -138,4 +142,5 @@
     LOGICAL ::  emissions_anthropogenic   = .FALSE.  !< namelist parameter: flag for turning on anthropogenic emissions
     LOGICAL ::  emission_output_required  = .TRUE.   !< internal flag for requiring emission outputs
+    LOGICAL ::  emiss_read_legacy_mode    = .TRUE.   !< namelist parameter: flag to read emission data using legacy mode
     LOGICAL ::  nesting_chem              = .TRUE.   !< apply self-nesting for the chemistry model
     LOGICAL ::  nesting_offline_chem      = .TRUE.   !< apply offline nesting for the chemistry model
Index: /palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4371)
+++ /palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4372)
@@ -22,11 +22,18 @@
 ! Current revisions:
 ! -----------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! chem_parin : added handler for new namelist item emiss_legacy_read_mode (ECC)
+! added messages
+! CM0465 - legacy read mode selection
+! CM0466 - legacy read mode force selection
+! CM0467 - new read mode selection
+!
+! 4370 2020-01-10 14:00:44Z raasch 
 ! vector directives added to force vectorization on Intel19 compiler
-! 
+!
 ! 4346 2019-12-18 11:55:56Z motisi
 ! Introduction of wall_flags_total_0, which currently sets bits based on static
@@ -2300,5 +2307,6 @@
          emiss_lod,                        &
          emiss_factor_main,                &
-         emiss_factor_side,                &                      
+         emiss_factor_side,                &
+         emiss_read_legacy_mode,           &
          icntrl,                           &
          main_street_id,                   &
@@ -2360,8 +2368,11 @@
  20 CONTINUE
 
+
+
 !
 !-- synchronize emiss_lod and mod_emis only if emissions_anthropogenic
 !-- is activated in the namelist.  Otherwise their values are "don't care"
     IF ( emissions_anthropogenic )  THEN
+
 !
 !--    check for emission mode for chem species
@@ -2410,7 +2421,7 @@
        
           message_string = 'Synchronizing mode_emis to defined emiss_lod'               //  &
-                           CHAR(10)  //  '          '                                   //  &
+                           CHAR(10)  //  '                    '                         //  &
                            'NOTE - mode_emis will be depreciated in future releases'    //  &
-                           CHAR(10)  //  '          '                                   //  &
+                           CHAR(10)  //  '                    '                         //  &
                            'please use emiss_lod to define emission mode'
  
@@ -2429,13 +2440,59 @@
 
           message_string = 'emiss_lod undefined.  Using existing mod_emiss setting'     //  &
-                           CHAR(10)  //  '          '                                   //  &
+                           CHAR(10)  //  '                    '                         //  &
                            'NOTE - mode_emis will be depreciated in future releases'    //  &
-                           CHAR(10)  //  '          '                                   //  &
-                           '       please use emiss_lod to define emission mode'
+                           CHAR(10)  //  '                    '                         //  &
+                           'please use emiss_lod to define emission mode'
 
           CALL message ( 'parin_chem', 'CM0464', 0, 0, 0, 6, 0 )
        ENDIF
 
+!
+!-- (ECC) input check for emission read mode.
+!--    legacy : business as usual (everything read / set up at start of run)
+!--    new    : emission based on timestamp, and for lod2 data is loaded on an hourly basis
+
+!
+!-- (ECC) handler for emiss_read_legacy_mode
+!-- * emiss_read_legacy_mode is defaulted to TRUE
+!-- * if emiss_read_legacy_mode is TRUE and LOD is 0 or 1,
+!--       force emission_read_legacy_mode to TRUE (not yet implemented)
+
+       IF ( emiss_read_legacy_mode )  THEN       !< notify legacy read mode
+
+          message_string = 'Legacy emission read mode activated'            // &
+                           CHAR(10)  //  '                    '             // &
+                           'All emissions data will be loaded '             // &
+                           'prior to start of simulation'
+          CALL message ( 'parin_chem', 'CM0465', 0, 0, 0, 6, 0 )
+
+       ELSE                                     !< if new read mode selected 
+
+          IF ( emiss_lod < 2 )  THEN            !< check LOD compatibility
+
+             message_string = 'New emission read mode '                    // &
+                              'currently unavailable for LODs 0 and 1.'    // &
+                              CHAR(10)  //  '                    '         // &
+                              'Reverting to legacy emission read mode'
+             CALL message ( 'parin_chem', 'CM0466', 0, 0, 0, 6, 0 )
+             emiss_read_legacy_mode = .TRUE.
+
+          ELSE                                  !< notify new read mode
+
+             message_string = 'New emission read mode activated'           // &
+                              CHAR(10)  //  '                    '         // &
+                              'LOD 2 emissions will be read on an '        // &           
+                              'hourly basis according to'                  // &             
+                              CHAR(10)  //  '                    '         // &
+                              'indicated timestamps'
+             CALL message ( 'parin_chem', 'CM0467', 0, 0, 0, 6, 0 )
+
+          ENDIF
+
+       ENDIF ! if emiss_read_legacy_mode
+ 
+                           
     ENDIF  ! if emissions_anthropengic
+
 
     t_steps = my_steps          